<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for DigitalProofAddressArray ArrayType
 * @subpackage Arrays
 */
class DigitalProofAddressArray extends AbstractStructArrayBase
{
    /**
     * The DigitalProofAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - ref: ns2:DigitalProofAddress
     * @var \StructType\DigitalProofAddress[]
     */
    public $DigitalProofAddress;
    /**
     * Constructor method for DigitalProofAddressArray
     * @uses DigitalProofAddressArray::setDigitalProofAddress()
     * @param \StructType\DigitalProofAddress[] $digitalProofAddress
     */
    public function __construct(array $digitalProofAddress = array())
    {
        $this
            ->setDigitalProofAddress($digitalProofAddress);
    }
    /**
     * Get DigitalProofAddress value
     * @return \StructType\DigitalProofAddress[]|null
     */
    public function getDigitalProofAddress()
    {
        return $this->DigitalProofAddress;
    }
    /**
     * This method is responsible for validating the values passed to the setDigitalProofAddress method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDigitalProofAddress method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDigitalProofAddressForArrayConstraintsFromSetDigitalProofAddress(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $digitalProofAddressArrayDigitalProofAddressItem) {
            // validation for constraint: itemType
            if (!$digitalProofAddressArrayDigitalProofAddressItem instanceof \StructType\DigitalProofAddress) {
                $invalidValues[] = is_object($digitalProofAddressArrayDigitalProofAddressItem) ? get_class($digitalProofAddressArrayDigitalProofAddressItem) : sprintf('%s(%s)', gettype($digitalProofAddressArrayDigitalProofAddressItem), var_export($digitalProofAddressArrayDigitalProofAddressItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DigitalProofAddress property can only contain items of type \StructType\DigitalProofAddress, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DigitalProofAddress value
     * @throws \InvalidArgumentException
     * @param \StructType\DigitalProofAddress[] $digitalProofAddress
     * @return \ArrayType\DigitalProofAddressArray
     */
    public function setDigitalProofAddress(array $digitalProofAddress = array())
    {
        // validation for constraint: array
        if ('' !== ($digitalProofAddressArrayErrorMessage = self::validateDigitalProofAddressForArrayConstraintsFromSetDigitalProofAddress($digitalProofAddress))) {
            throw new \InvalidArgumentException($digitalProofAddressArrayErrorMessage, __LINE__);
        }
        $this->DigitalProofAddress = $digitalProofAddress;
        return $this;
    }
    /**
     * Add item to DigitalProofAddress value
     * @throws \InvalidArgumentException
     * @param \StructType\DigitalProofAddress $item
     * @return \ArrayType\DigitalProofAddressArray
     */
    public function addToDigitalProofAddress(\StructType\DigitalProofAddress $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DigitalProofAddress) {
            throw new \InvalidArgumentException(sprintf('The DigitalProofAddress property can only contain items of type \StructType\DigitalProofAddress, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DigitalProofAddress[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DigitalProofAddress|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DigitalProofAddress|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DigitalProofAddress|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DigitalProofAddress|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DigitalProofAddress|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DigitalProofAddress
     */
    public function getAttributeName()
    {
        return 'DigitalProofAddress';
    }
}
