<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArtworkFileArray' => '\\ArrayType\\ArtworkFileArray',
            'ArtworkFile' => '\\StructType\\ArtworkFile',
            'Artwork' => '\\StructType\\Artwork',
            'Charge' => '\\StructType\\Charge',
            'Configuration' => '\\StructType\\Configuration',
            'ChargeArray' => '\\ArrayType\\ChargeArray',
            'LocationArray' => '\\ArrayType\\LocationArray',
            'ContactDetails' => '\\StructType\\ContactDetails',
            'Contact' => '\\StructType\\Contact',
            'Decoration' => '\\StructType\\Decoration',
            'DigitalProofAddress' => '\\StructType\\DigitalProofAddress',
            'DigitalProof' => '\\StructType\\DigitalProof',
            'DigitalProofAddressArray' => '\\ArrayType\\DigitalProofAddressArray',
            'Dimensions' => '\\StructType\\Dimensions',
            'FreightDetails' => '\\StructType\\FreightDetails',
            'LayerOrStop' => '\\StructType\\LayerOrStop',
            'Layers' => '\\StructType\\Layers',
            'LayerOrStopArray' => '\\ArrayType\\LayerOrStopArray',
            'Location' => '\\StructType\\Location',
            'DecorationArray' => '\\ArrayType\\DecorationArray',
            'Part' => '\\StructType\\Part',
            'ShipmentLinkArray' => '\\ArrayType\\ShipmentLinkArray',
            'Program' => '\\StructType\\Program',
            'Quantity' => '\\StructType\\Quantity',
            'ServiceMessageArray' => '\\ArrayType\\ServiceMessageArray',
            'ServiceMessage' => '\\StructType\\ServiceMessage',
            'ShipmentLink' => '\\StructType\\ShipmentLink',
            'Shipment' => '\\StructType\\Shipment',
            'ShipTo' => '\\StructType\\ShipTo',
            'TaxInformation' => '\\StructType\\TaxInformation',
            'ThirdPartyAccount' => '\\StructType\\ThirdPartyAccount',
            'ToleranceDetails' => '\\StructType\\ToleranceDetails',
            'TypesetArray' => '\\ArrayType\\TypesetArray',
            'Typeset' => '\\StructType\\Typeset',
            'GetSupportedOrderTypesRequest' => '\\StructType\\GetSupportedOrderTypesRequest',
            'GetSupportedOrderTypesResponse' => '\\StructType\\GetSupportedOrderTypesResponse',
            'LineItem' => '\\StructType\\LineItem',
            'PartArray' => '\\ArrayType\\PartArray',
            'PO' => '\\StructType\\PO',
            'OrderContactArray' => '\\ArrayType\\OrderContactArray',
            'ShipmentArray' => '\\ArrayType\\ShipmentArray',
            'LineItemArray' => '\\ArrayType\\LineItemArray',
            'TaxInformationArray' => '\\ArrayType\\TaxInformationArray',
            'SendPORequest' => '\\StructType\\SendPORequest',
            'SendPOResponse' => '\\StructType\\SendPOResponse',
        );
    }
}
