<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for TransportMechanismType EnumType
 * Meta information extracted from the WSDL
 * - documentation: The type of transport mechanism
 * @subpackage Enumerations
 */
class TransportMechanismType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'ArtworkToFollow'
     * @return string 'ArtworkToFollow'
     */
    const VALUE_ARTWORK_TO_FOLLOW = 'ArtworkToFollow';
    /**
     * Constant for value 'Email'
     * @return string 'Email'
     */
    const VALUE_EMAIL = 'Email';
    /**
     * Constant for value 'Ftp'
     * @return string 'Ftp'
     */
    const VALUE_FTP = 'Ftp';
    /**
     * Constant for value 'Url'
     * @return string 'Url'
     */
    const VALUE_URL = 'Url';
    /**
     * Return allowed values
     * @uses self::VALUE_ARTWORK_TO_FOLLOW
     * @uses self::VALUE_EMAIL
     * @uses self::VALUE_FTP
     * @uses self::VALUE_URL
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ARTWORK_TO_FOLLOW,
            self::VALUE_EMAIL,
            self::VALUE_FTP,
            self::VALUE_URL,
        );
    }
}
