<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DigitalProof StructType
 * @subpackage Structs
 */
class DigitalProof extends AbstractStructBase
{
    /**
     * The DigitalProofAddressArray
     * @var \ArrayType\DigitalProofAddressArray
     */
    public $DigitalProofAddressArray;
    /**
     * The required
     * Meta information extracted from the WSDL
     * - documentation: A Boolean value set to TRUE indicates a proof is required for this purchase order; the value is FALSE otherwise.
     * @var bool
     */
    public $required;
    /**
     * Constructor method for DigitalProof
     * @uses DigitalProof::setDigitalProofAddressArray()
     * @uses DigitalProof::setRequired()
     * @param \ArrayType\DigitalProofAddressArray $digitalProofAddressArray
     * @param bool $required
     */
    public function __construct(\ArrayType\DigitalProofAddressArray $digitalProofAddressArray = null, $required = null)
    {
        $this
            ->setDigitalProofAddressArray($digitalProofAddressArray)
            ->setRequired($required);
    }
    /**
     * Get DigitalProofAddressArray value
     * @return \ArrayType\DigitalProofAddressArray|null
     */
    public function getDigitalProofAddressArray()
    {
        return $this->DigitalProofAddressArray;
    }
    /**
     * Set DigitalProofAddressArray value
     * @param \ArrayType\DigitalProofAddressArray $digitalProofAddressArray
     * @return \StructType\DigitalProof
     */
    public function setDigitalProofAddressArray(\ArrayType\DigitalProofAddressArray $digitalProofAddressArray = null)
    {
        $this->DigitalProofAddressArray = $digitalProofAddressArray;
        return $this;
    }
    /**
     * Get required value
     * @return bool|null
     */
    public function getRequired()
    {
        return $this->required;
    }
    /**
     * Set required value
     * @param bool $required
     * @return \StructType\DigitalProof
     */
    public function setRequired($required = null)
    {
        // validation for constraint: boolean
        if (!is_null($required) && !is_bool($required)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($required, true), gettype($required)), __LINE__);
        }
        $this->required = $required;
        return $this;
    }
}
